<script>
  import { extent } from "d3-array";
  import { select } from "d3-selection";
  import { scaleLinear } from "d3-scale";
  import { axisBottom, axisLeft } from "d3-axis";
  import { brush } from "d3-brush";

  // Properties
  export let data = [];
  export let x = (d) => d.x;
  export let y = (d) => d.y;
  export let xLabel = "x";
  export let yLabel = "y";
  export let myRange = null;
  export let selectionMask = [];
  export let globalMask = [];

  // Dimensions
  const width = 400;
  const height = 300;
  const margin = { top: 10, right: 10, bottom: 35, left: 45 };
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;

  // Scales
  const xScale = scaleLinear().domain(extent(data, x)).range([0, innerWidth]);
  const yScale = scaleLinear().domain(extent(data, y)).range([innerHeight, 0]);

  // Axes
  const xAxis = (node) => axisBottom(xScale)(select(node));
  const yAxis = (node) => axisLeft(yScale)(select(node));

  // Brushing
  // The range of the selection rectangle.
  // If there is no active selection, it contains: null,
  // otherwise, it contains: [ [x0, y0], [x1, y1] ]
  function createBrush(g) {
    brush().on(
      "end",
      ({ selection }) => (myRange = selection)
    )(select(g));
  }

  // Coords
  $: coords = data.map((d) => {
    return { x: x(d), y: y(d) };
  });

  $: if (myRange) {
    console.log("Setting myRange", myRange);
    const [[x0, y0], [x1, y1]] = myRange;
    const between = (value, lower, upper) => value >= lower && value <= upper;
    selectionMask = coords.map(({ x, y }) => {
      return between(xScale(x), x0, x1) && between(yScale(y), y0, y1);
    });
    console.log("selection mask", selectionMask)
  } else {
    selectionMask = coords.map((_) => true);
  }

  $: globalMask;

</script>

<svg viewBox="0 0 {width} {height}" class="mx-2" style="max-width: {width}px">
  <g transform="translate({margin.left},{margin.top})">
    <g use:createBrush>
      {#if coords}
        {#each coords as c, i}
          <circle
            cx={xScale(c.x)}
            cy={yScale(c.y)}
            r={3}
            fill={globalMask[i] ? "steelblue" : "darkgray"}
            fill-opacity={globalMask[i] ? "0.5" : "0.3"}
            stroke={globalMask[i] ? "steelblue" : "darkgray"}
            stroke-width="1.5"
            stroke-opacity={globalMask[i] ? "1" : "0.5"}
          />
        {/each}
      {/if}
    </g>
    <g use:xAxis transform="translate(0, {innerHeight})">
      <text class="axisLabel" x={innerWidth / 2} y={margin.bottom - 5}
        >{xLabel}</text
      >
    </g>
    <g use:yAxis>
      <text
        class="axisLabel"
        y={-margin.left + 10}
        x={-innerHeight / 2}
        transform="rotate(-90)">{yLabel}</text
      >
    </g>
  </g>
</svg>

<style>
  .axisLabel {
    text-anchor: middle;
    vertical-align: bottom;
    fill: currentcolor;
  }
</style>
